/*****************************************************************************/
//	ArrayArg.h
/*****************************************************************************/

#ifndef _ArrayArg_H_
#define _ArrayArg_H_

#include "ConstArg.h"

class corCArg;
/*****************************************************************************/

// Make sure that COR_ArrayKind is distinct from the other arg subkinds
#define COR_ArrayKind 1

/*****************************************************************************/

class corArrayArg : public corConstArg {
public:
	// optional methods

	virtual corCArg lookup(int i) const = 0;
	virtual int bind(int i, corCArg *arg) = 0;
	virtual corArrayArg* make_version() = 0;
	virtual int size() = 0;

	// mandatory methods

	virtual arg_kind kindof() const		{ return COR_CONST_ARG;}
	virtual int subkind()				{ return (COR_ArrayKind);}
	virtual int equals(corArg *arg);
	virtual void print(corBindEnv *context, FILE *file) const = 0;
	virtual void print(corBindEnv *context, FILE *file, char *) const {
		print(context, file);
	}
	virtual void sprint(char *str, int *pos, corBindEnv *context = NULL) const;
	virtual void dump(int arg_number, FILE *file);
	virtual int isConstant()			{ return 1;}
	virtual HashVal hash(corBindEnv *)		{return corIntToHash((int)this);}
};

/*****************************************************************************/

extern char *corArrayDestructorString;
extern char *corArrayConstructorString;
extern char *corArrayLookupString;
extern char *corArrayBindString;

/*****************************************************************************/

#endif _ArrayArg_H_

