
/* ###################################################### 
   #
   # A simple client/server protocol for coral clients.
   #
   # The client continues to dump in straight coral commands (with 
   # the addition of excl,end, etc, etc)
   #
   # All messages to the client are preceeded by a 5 char identifier
   # (which always ends with a colon, to keep it Human readable).
   # These identifiers should be used only when coral is running
   # in server mode.  
   #
   # These fixed length identifiers will be extreemely easy to parse
   # out, keeping the client simple.
   #
   ######################################################## */

    /* "OKAY:" */
    /* Command finished - succeded, client will prompt the user again now */
#define    CP_OKAY    "OKAY:"

    /* "SYNC:number" */
    /* Client requested synchronization, this is the response */
#define  CP_SYNC  "SYNC:"

    /* "CERR:string" */
    /* Usually an error message, indicates command failed */
#define    CP_CERR    "CERR:"

    /* "MESG:string" */
    /* Answer to query, anything else that should be shown to the user */
#define    CP_MESG    "MESG:"

    /* "USER:number" */
    /*    The numerical user id assigned to this client's user */  
#define    CP_USER    "USER:"

    /* "LOGN:string" */
    /*    The login name of this user */  
#define    CP_LOGIN   "LOGN:"

    /* "R_ID:number" */
    /* A resume id */
#define    CP_R_ID    "R_ID:"

    /* "PRMT:string" */
    /* Indicates the prompt should be changed to "string" */
    /* (Only needed for changing workspaces) */
#define    CP_PRMT    "PRMT:"

    /* "PSWD:string" */
    /* The user's password, echoed back */
#define    CP_PSWD    "PSWD:"

    /* "EXPL:conn_id user_id" */
    /* The connection id and user id of this connection, to be passed
       to explain (which the server suggests you start) */ 
#define    CP_EXPL    "EXPL:"

    /* "EXIT:" */
    /* Inform the client that they are being disconnected */
#define    CP_EXIT    "EXIT:"
