/*****************************************************************************/
//    Compile.h
/*****************************************************************************/

#ifndef _Compile_H_
#define _Compile_H_

#include "Table.h"
#include "SymbolArg.h"
#include "VarArg.h"
#include "ModulePred.h"

/*****************************************************************************/

class corParserStruct;
class corRuleInfoArray;
class corSemiNaive;
class corQFModuleData;
class corPredicate;
class corSccInfo;

/*****************************************************************************/

int corget_offset(corTable *F, Name name, int arity, int print_error = 1);
int corget_offset(corTable *F, corLiteral *pred, int print_error = 1);

int corcount_var_list(corVarLink *rest);

void corcompile_single_rule(corParserStruct &corparserStruct, corTable* &module_table,
    corRuleInfoArray* &module_rules, corSemiNaive &snrule);

void corinterpret_module(corParserStruct &corparserStruct);

int cordetermine_subsum_status(corQFModuleData *md, Name name, int default_val);
void corget_annos(corQFModuleData *md, corModulePred *predicate);

int corFind_RMark_Offset(corSccInfo *scc_info, corPredicate *rpred);

int corhas_fail_in_body(corClause *rule);

void coradd_pred_extern(corPredicate *pred, PredKind kind, corModulePred *predicates);

void corinitialize_scc_structs();
int corfind_predicates_invoked_from(corPredicate *pred, int original = 0);
void cornumber_sccs(struct corScc *Sccs);

/*****************************************************************************/

#endif _Compile_H_


