/*****************************************************************************/
//    Database.h
/*****************************************************************************/

#ifndef _Database_H_
#define _Database_H_

#include <stdio.h>

#include "DatabaseStruct.h"
#include "SymbolArg.h"
#include "FuncArg.h"
#include "Globals.h"

/*****************************************************************************/

extern corDatabaseStruct corBuiltinDB;
extern corDatabaseStruct *corCurDB;

/*****************************************************************************/

#define COR_DB_RELS "exodus_ws"
#define COR_BUILTINS "builtin_ws"

typedef Association (*Func)(Pointer, Association*);

/*****************************************************************************/

corDatabaseStruct *corlookupDB(Name name);
corDatabaseStruct *corcreateDB(Name name);
void corclearDatabases();
int coraddDBStruct(corDatabaseStruct *db);
int cordestroyDB(Name name);
int corcurrentDB(Name name);
int correnameDB(Name dbname, Name newName);
int corsaveDB(Name dbname, FILE *outf);
int corcopyToDB(corFuncArg *srcrel, Name dbname, corFuncArg *dstrel);
int coraddToDB(corFuncArg *srcrel, Name dbname, corFuncArg *dstrel);
int corremoveRelFromDB(corFuncArg *rel, Name dbname);
int corclearRelInDB(corFuncArg *rel, Name dbname);
int coropenRelInCurDB(corFuncArg *rel, Name dbname);
int corlistEveryDB();
int corlistRelsInDB(Name dbname, FILE *outfile = stderr);

int correnameRelation(Name relname, Name newName);
Association corclear_relation(Pointer , Association* ass);

/*****************************************************************************/

#endif _Database_H_

