// *************************************************************************
//    Literal.h
// *************************************************************************

#ifndef _Literal_H_
#define _Literal_H_

#include "Predicate.h"
#include "SymbolArg.h"
#include "ArgList.h"
//#include "Rule.h"
#include "BitVector.h"

// *************************************************************************

enum pred_kind {
    COR_REGULAR,
    COR_MAGIC,
    COR_SUPMAGIC,
    COR_FACTORMAGIC,
    COR_DONE_MAGIC
};

// *************************************************************************

class Rule;

// *************************************************************************
// A Literal is an adorned predicate with some instantiation of its terms.
// NOTE : Literal is of variable size, since ArgList is of variable size.
// Therefore, it should NOT be allocated using a simple new() ! Use
// AllocLiteral(). 

class corLiteral {
private:

public:
    corPredicate*        predicate;
    pred_kind        kind;

    // The pred,rule fields should be subsumed by rel !!
    Name pred;            // index into global preds[] for REG, MAG 
    corClause*    rule;        // rule, pos for COR_SUPMAGIC preds
    int    pos;
    corClause* supp_rule;   // used in nested_scc rewriting ONLY
    int    base_pred;        // 1 if this is a base predicate
    int    negated;        // 1 if predicate is negated
    corBitVector adorn;
    struct corRelation* rel;
    corArgList    args;

    corLiteral(corParserStruct& corparserStruct, Name name, int arg_count);
    corLiteral(corParserStruct& corparserStruct, corCArg* cname, int arg_count);

    corLiteral(int arg_count);
   ~corLiteral();

    inline int arity()        { return args.count(); }
    inline Name name()const    { return predicate->name;};
};

// *************************************************************************

#endif _Literal_H_

