// *************************************************************************
//    ModuleInfo.h
// *************************************************************************

#ifndef _ModuleInfo_H_
#define _ModuleInfo_H_

#include <stdio.h>

#include "SymbolArg.h"
//#include "ExportInfo.h"
#include "Profile.h"

// *************************************************************************

class corExportInfo;

// *************************************************************************

class corModuleInfo {
public:
    Name name;                    // Name of the module
    corExportInfo *ExportedPreds;    // List of exported queries
                                  //         (preds with adornments)

    corProfileInfo corGlobalProfileInfo; // profile info for module

    int ExportedCount;             // Length of above list

    int PreProcessing;             // perform preprocessing on this module
    int SingleScc;                 // lump all rules into a single scc
    int ConvertFunctions;          // convert arithemetic functions
    int SingleAnswer;              // the exported relation has a single answer
                                   // per binding

    int Rewriting;                 // perform rewriting on this module
    int SaveModule;                // Save facts on exiting call to 
                                   //        module if this is set
    int UseSupplementaryMagic;
    // This is probably redundant .. UseMagic, because of UseFactoring
    int UseMagic;                  // Do magic transformation if set
    int UseExistOpt;               // Do existential query optimization
    int UseFactoring;              // Do factoring if set
    int UseFactorMagic;            // Do factoring with a magic predicate
                                   //        guarding every rule
    int SupMagicIndexing;          // Use supplementary magic indexing
    int UsePredicateSN;            // Use predicate seminaive evaluation
    int CheckSubsum;               // Subsumption checking status
    int MultiSet ;                 // MultiSet semantics
    int IndexDeltas;               // Index the deltas of all relations
    int UseReturnUnify;            // Use special opts for return unification
    int UsePipelining;             // Use pipelined evaluation mode
    int UseOrdSearch;              // Use ordered search
    int EagerEval;                 // Don't use eager evaluation
    int Monotonic;                 // Don't use done_m_ literals if set
    int NonGroundFacts;            // Non-ground facts are present
    int HasPrioritize;             // There is a predicate with priority anno.
    int DiskRel;                   // All derived relations are disk-resident
    int NestedSccEval;             // Use nested-Scc evaluation: Added by Ken

    corModuleInfo() { init(); };

    void init_flags();
    void init();
};

/*****************************************************************************/

#endif _ModuleInfo_H_

