/*****************************************************************************/
//	NumArg.h
/*****************************************************************************/

#ifndef _NumArg_H_
#define _NumArg_H_

#include "ConstArg.h"

/*****************************************************************************/

enum numarg_kind { COR_INTEGER ,
		   COR_DOUBLE ,
		   COR_ARITH_EXPR ,
		   COR_AVG_ARG ,
		   COR_DIST_ARG ,
		   COR_ADIST_ARG ,
		   COR_NOT_A_NUMBER };


/*****************************************************************************/

typedef struct corNumArg Root;

struct corNumArg : public corConstArg {
	numarg_kind _num_kindof;
	union {
		int i_val;
		double d_val;
	 };

	inline corNumArg() { _kindof = COR_NUM_CONST; _num_kindof = COR_NOT_A_NUMBER;}
	inline corNumArg(int i) { _kindof = COR_NUM_CONST; _num_kindof = COR_INTEGER; i_val = i;}
	inline corNumArg(double d) { _kindof = COR_NUM_CONST; _num_kindof = COR_DOUBLE; d_val = d;}
	virtual ~corNumArg() {};
	inline numarg_kind num_kindof() const { return _num_kindof; }
	inline double doubval() const { return ((_num_kindof == COR_DOUBLE) ? d_val : (double)i_val) ;}
	virtual int equals(corArg *arg2);
	virtual int compare(const Root&) const;

	virtual void printon(FILE *) const;
	virtual void printon(FILE *, char *) const;
	virtual void print(corBindEnv*, FILE *file, char *fmt_str) const { printon(file, fmt_str);}
	virtual void print(corBindEnv*, FILE *file) const { printon(file); }
	virtual void sprint(char *str, int *pos, corBindEnv *context = NULL) const;
	virtual HashVal hash(corBindEnv *context = NULL);

	virtual corCArg simplify(corBindEnv *context, corTermLink *&renamed_vars,
		corBindEnv *const_env, corBindEnv *rename_only_env);
};

/*****************************************************************************/
/*
extern const NumArg *Zero, *One, *MinusOne;
extern "C" NumArg *MakeFixInt(int i);
extern "C" NumArg *NewDouble(double d);
*/
/*****************************************************************************/

#endif _NumArg_H_

