/*****************************************************************************/
//    PersistentIndexSet.h
/*****************************************************************************/

#ifndef _PersistentIndexSet_H_
#define _PersistentIndexSet_H_

#ifdef WITH_PERSISTENCE

#include "GenericIndex.h"
#include "GenericIndexSet.h"




/*****************************************************************************/

#define Scanning_Persistent 1

#define COR_PERS_INDEX 2

/*****************************************************************************/

class corPersistentRel;

class corPersistentIndexSet : public corGenericIndexSet {
public:
    corPersistentIndexSet( corPersistentRel *reln ) : 
      corGenericIndexSet((corStorageRelation *)reln) {};

    //    Finds the index that best "matches" the given argument set in
    //    the iterator.
    virtual corGenericIndex *find_index( corTupleIterator& iterator) {
        return
            find_index(iterator.arg_list,iterator.bindenv,iterator.indexnump);
    };

    virtual corGenericIndex *find_index(corTuple* tuple, int *tryindexp=NULL) {
        return find_index(*(tuple->_args), tuple->bindenv, tryindexp);
    };

    virtual corGenericIndex *find_index(corArgList&, corBindEnv*, int *tryindexp=NULL);

    //    Add an index to the set of known indices
    virtual int insert_index(corGenericIndex* index);

    //    Fill in the index using default index in posn. 0
    virtual void fill_index(corGenericIndex* Index);
};

/*****************************************************************************/

#endif WITH_PERSISTENCE

#endif _PersistentIndexSet_H_

