/*****************************************************************************/
//  reference.h
/*****************************************************************************/

/*****************************************************************************/

class corRefdData {
    friend class corReference;
public:
    corRefdData()            { ref_count = 0; };
    virtual ~corRefdData()        { };
    void IncRef();
    void DecRef();
protected:
    short int ref_count;
};


void inline corRefdData::IncRef()
{
    ref_count++;
}

void inline corRefdData::DecRef()
{
#   ifdef DEBUG
    if (ref_count <= 0) {
    fprintf(corexEnv->error_file,"fatal error: reference count < 0\n");
    // dump core
    }
#   endif

    if (--ref_count == 0) delete this;
}

/*****************************************************************************/

class corReference {
public:
    corReference()                { ptr = NULL; };
    corReference(corReference& r)        { if (ptr = r.ptr) ptr->IncRef(); };
    corReference(corRefdData* d)        { if (ptr = d) ptr->IncRef(); };
    ~corReference()            { if (ptr) ptr->DecRef(); };

    void operator=(corReference& src);
    void operator=(corRefdData* d);
    corRefdData operator*()        { return(*ptr); };
    corRefdData* operator->()        { return(ptr); };
    operator corRefdData*()        { return(ptr); };
protected:
    corRefdData* ptr;
};

inline void corReference::operator=(corReference& src)
{
    if (ptr) ptr->DecRef();
    if (ptr = src.ptr) ptr->IncRef();
}

inline void corReference::operator=(corRefdData* d)
{
    if (ptr) ptr->DecRef();
    if (ptr = d) ptr->IncRef();
}

/*****************************************************************************/

