/*****************************************************************************/
//    TableStack.h
/*****************************************************************************/

#ifndef _TableStack_H_
#define _TableStack_H_

#include "Table.h"
#include "Globals.h"

/*****************************************************************************/

typedef struct corTableStack corTableStack;
extern corTableStack corT_Stack;
extern corExecutionEnv *corexEnv;

struct corTableStack {
public:
    corTable** tables;
    int count;
    inline corQFModuleData *cur_md() { return tables[count-1]->moduledata; }
    inline corTable *& operator[](int index) const { return tables[index]; }
    inline corTable * top() const { return tables[count-1];}
    inline void push(corTable *new_entry) {
        if (corT_Stack.count >= corexEnv->C_max_recursion_depth_default) {
            fprintf(corexEnv->error_file,
                "CORAL Error::Out of recursion stack space !!\n");
            fprintf(corexEnv->error_file, " Current max stack size = %d\n",
                corexEnv->C_max_recursion_depth_default);
            fprintf(corexEnv->error_file,
                " Use assign(recursion_depth, <new_value>) to increase it !\n");
            fprintf(corexEnv->error_file, " Aborting query !\n");
            corexEnv->C_interrupt_raised = 1;
        }
        tables[count++] = new_entry;
    }
    inline void pop() {
        tables[--count] = NULL;
    }
    corTableStack(int size) {
        tables = new corTable *[size];
        count = 0;
    }
};

/*****************************************************************************/

#endif _TableStack_H_

