/*****************************************************************************/
//	Unify.h
/*****************************************************************************/

#ifndef _Unify_H_
#define _Unify_H_

#include "BindEnv.h"
#include "VarArg.h"
#include "Term.h"
#include "ArgList.h"

/*****************************************************************************/

class corTuple;
class corTupleIterator;

/*****************************************************************************/

#define COR_U_FAIL 0
#define COR_U_SUCCEED 1

/*****************************************************************************/

/** unify_binding and subsumes_binding used Term &term earlier **/

int corunify_binding (corBindEnv *env, Variable var, corTerm term);
int corunify_args (corTerm left, corTerm right);
int corunify_arg_lists (corArgList& left, corArgList& right, corBindEnv *left_bindings,
	corBindEnv *right_bindings);
int corunify_literal(corTupleIterator& iterator, corTuple *tuple, int display);

int corsubsumes_tuple(corTuple *tuple, corTuple *newtuple, int display);
int corsubsumes_binding(corBindEnv* bindenv, Variable var, corTerm term, int can_bind);
int corsubsumes_arg_lists(corArgList& left, corArgList& right, corBindEnv *left_bindings,
	corBindEnv *right_bindings);
int corsubsumes_value(AggregateKind aggkind, corCArg val1, corCArg val2, corBindEnv *env1,
		corBindEnv *env2) ;

int corequal_tuples(corTuple *tuple1, corTuple *tuple2, int display);

/*****************************************************************************/

#endif _Unify_H_

