/*****************************************************************************/
//    Unparse.h
/*****************************************************************************/

#ifndef _Unparse_H_
#define _Unparse_H_

#include <stdio.h>

#include "BitVector.h"
#include "Rule.h"
#include "Sips.h"
#include "PredAnnotations.h"
#include "ModuleInfo.h"

/*****************************************************************************/

#define allargsfree(corb) ( (corb)->next(-1) < 0 )

/*****************************************************************************/

void corprint_rule(corClause *rule, FILE *out);
void corsprint_rule(corClause *rule, char *str);

void corprint_rule_with_order(corClause *rule, int *predOrders, int *markOffsets,
               int recursive, FILE* out);

void corprint_pred( corLiteral *p, FILE *out, int head=0);

void corprint_adornment_brack(corBitVector& a, FILE *file);

void corprint_sip(corClause *r, struct corsip *s, FILE *out);
void corprint_sips(corClause *r, struct corsips *s, FILE *out);

void sprint_adornment(char *buf, corBitVector *adorn);
void sprint_adornment(char *buf, char *a);
void corprint_adornment(corBitVector& a, FILE *file);
void corprint_adornment(corBitVector *a, FILE *file);
void corprint_adornment(char *a, FILE *file);

void corsprint_magic_name(char *buf, char *name, corBitVector *adorn);
void corsprint_magic_name(char *buf, char *name, char *adorn);
void corfprint_magic_name(FILE *out, char *name, corBitVector *adorn);
void corfprint_magic_name(FILE *out, char *name, char *adorn);

void corsprint_pred_name(char *buf, char *name, corBitVector *adorn);
void corsprint_pred_name(char *buf, char *name, char *adorn);
void corfprint_pred_name(FILE *out, char *name, corBitVector *adorn);
void corfprint_pred_name(FILE *out, char *name, char *adorn);

void corprint_allowed_adornment_annotations(corPredAnnotations *anno,FILE *file);
void corprint_make_index_annotations(corPredAnnotations *anno, FILE *file);
void corprint_agg_sel_annotations(corPredAnnotations *anno, FILE *file);
void corprint_diskrel_annotations(corPredAnnotations *anno, FILE *file);
void corprint_prioritize_annotations(corPredAnnotations *anno, FILE *file);
void corprint_MultisetAnnotations(corPredAnnotations *anno, FILE *file);
void corprint_Annotations(corModuleInfo& module_info, FILE *file,
    corPredAnnotations *index, corPredAnnotations *agg_sel,
    corPredAnnotations *allowed_adorn, corPredAnnotations *multiset,
    corPredAnnotations *prioritize_annotations, corPredAnnotations *diskrel);

/*****************************************************************************/

#endif _Unparse_H_

