#ifndef _LOG_H_
#define _LOG_H_

// Establishes an efficient (removable) logging method for debugging.
// Add -DDO_LOGGING as a compile option to include logging.
// If DO_LOGGING is defined, LOG('a' << " stream " << " message...")
// will be printed (which source file & line number of message if desired).
// If it is not defined, no code will be added to the program.

#include "LogHandler.h"

#ifdef DO_LOGGING

#define LOG(M) LOG_MSG(klog,M)
 extern LogHandler klog;

#else // !DO_LOGGING

#define LOG(M)

#endif // DO_LOGGING


#endif // _LOG_H_
