/*****************************************************************************/
//	FixedArrayArg.h
/*****************************************************************************/

#ifndef _FixedArrayArg_H_
#define _FixedArrayArg_H_

#include <stdio.h>

#include "ArrayArg.h"
#include "BuiltinSymbols.h"
#include "CArg.h"

/*****************************************************************************/

class corFixedArrayArg : public corArrayArg {
	int _size;
	corCArg* corarray;
public:
	// Optional methods
	corFixedArrayArg ( int size1);
	virtual inline corCArg lookup(int i) const { 
		if( i < 0 || i > _size)
			return corNullCArg;
		else return (corarray)[i];
	}
	virtual inline int bind(int i, corCArg *arg) {
		if( i < 0 || i > _size)
			return -1;
		else {
			(corarray)[i] = *arg;
			return 1;
		}
	}

	virtual int size() { return _size; }

	virtual corArrayArg* make_version();

	// Mandatory Methods
	virtual void print(corBindEnv *context, FILE *file) const;
	virtual void print(corBindEnv *context, FILE *file, char *) const {
		print(context, file);
	};
};

/*****************************************************************************/

#endif _FixedArrayArg_H_

