// *************************************************************************
//	SymbolArg.h
// *************************************************************************

#ifndef _SymbolArg_H_
#define _SymbolArg_H_

#include "ConstArg.h"

// *************************************************************************
// All strings belong to this class
// *************************************************************************

typedef struct corSymbol : public corConstArg {
	// Each symbol is identified by a hash value and a length
	HashVal _hash;
	int _length;
	char *str;
	// actually has char data[length];

	inline corSymbol(const char *s, int length, HashVal h) {
		_hash = h;
		_length = length;
		str = new char[++length];
		memcpy(str, s, length);
		_kindof = COR_SYMBOL_CONST;
	}
	  
	inline corSymbol(HashVal h, int l) { 
                _hash = h;
                _length = l;
                _kindof = COR_SYMBOL_CONST;
		str = NULL;
            }
	virtual ~corSymbol() { if (str) delete [] str; }

	inline int Length() const { return (int) _length; }
	inline int length() const { return (int) _length; }

	inline char *string() const { return str; }
	unsigned char *ustring() const { return (unsigned char*)str; }
	inline corSymbol *sym_name() const { return (corSymbol*)this; }

	virtual int equals(corArg *arg2);

        // Special method to print strings without quotes
        void print_nq(corBindEnv*, FILE *file) const;
	virtual void print(corBindEnv*, FILE *file) const;
	virtual void print(corBindEnv*, FILE *file, char *fmt_str) const;
	virtual void sprint(char *str, int *pos, corBindEnv *context = NULL) const;

	virtual HashVal hash(corBindEnv *context = 0) { return _hash; };
} corSymbol;

typedef corSymbol *Name;

inline char* corSymbolString(Name s) {
  return s->str;
 };


// *************************************************************************

#define SymbolLength(s) (((corSymbol*)(s))->_length)
#define SymbolHash(s) (((corSymbol*)(s))->_hash)
// SymbolString(s) (((s).SymbolP())->str)
#define SymbolUnsignedString(s) ((unsigned char*)corSymbolString(s))

extern void corPrintSymbol(Name sym, FILE *ff);
extern Name corEnterSymbol(const char *);
extern Name InsertSymbol(const char *, int len);
extern Name corDontCareSymbol;

// *************************************************************************

#endif _SymbolArg_H_

