/*****************************************************************************/
//    BuiltinCompareRelation.C
/*****************************************************************************/

#include "BuiltinCompareRelation.h"

#include "TupleIterator.h"
#include "InitBuiltins.h"

/*****************************************************************************/
corBuiltinCompareRelation::corBuiltinCompareRelation(int a, Name n, CompareProc c_op)
    : corBuiltinRelation(a, n, NULL)
{
    op = c_op;
}

/*****************************************************************************/
corBindEnv * corBuiltinCompareRelation::get_next(corTupleIterator& iterator)
{
    corBindEnv *env = iterator.bindenv;

    if (iterator.ipos > 0) {
        iterator.stack_mark.pop_to();
        iterator.set_no_match();
        return env; 
    }
    iterator.ipos++;
    iterator.stack_mark.get_mark();

    //Term terms[2];
    for (int i = 0; i < 2; i++) {
        corstatic_terms[i].expr = iterator.arg_list[i],
            corstatic_terms[i].bindenv = env;
        FULL_DEREFERENCE_TERM(corstatic_terms[i]);
    }
    
    if (!(*op)(corstatic_terms[0], corstatic_terms[1]))
        iterator.set_no_match();
    if (iterator.no_match())
        iterator.stack_mark.pop_to();
    return (env);
}

/*****************************************************************************/

