/*****************************************************************************/
//    BacktrackInfoArray.C
/*****************************************************************************/

#include "BacktrackInfoArray.h"

#include "RuleInfo.h"
#include "Backtrack.h"

/*****************************************************************************/

static void initFailureBackTrack(corRuleInfo *rInfo, int *ib_first_array,
    int *ib_next_array, int non_ground);

/*****************************************************************************/
corBacktrackInfoArray::corBacktrackInfoArray(corRuleInfoArray *rArray, int non_ground)
{
    numRules = rArray->numRules;
    firstFailureBacktrackArrays = new int* [numRules];
    nextFailureBacktrackArrays = new int* [numRules];
    successBacktrackPoints = new int [numRules];

    for (int i = 0; i < numRules; i++) {
        successBacktrackPoints[i] =
            corgetSuccessBacktrackPoint(rArray->rInfoPtrs[i], non_ground);

        if (rArray->rInfoPtrs[i]->num_literals) {
            firstFailureBacktrackArrays[i] =
                new int[rArray->rInfoPtrs[i]->num_literals];
            nextFailureBacktrackArrays[i] =
                new int[rArray->rInfoPtrs[i]->num_literals];

            initFailureBackTrack(rArray->rInfoPtrs[i],
                firstFailureBacktrackArrays[i], nextFailureBacktrackArrays[i],
                non_ground);
        }
    }
}


/*****************************************************************************/
static void initFailureBackTrack(corRuleInfo *rInfo, int *ib_first_array,
    int *ib_next_array, int non_ground)
{
    for (int i = rInfo->num_literals-1; i >0; i--) {
        ib_first_array[i] = corgetfirstFailureBacktrackPoint(rInfo, i, non_ground);
        ib_next_array[i] = corgetnextFailureBacktrackPoint(rInfo, i, non_ground);
    }
    ib_first_array[0] = -1;
    ib_next_array[0] = -1;
}

/*****************************************************************************/

