/*****************************************************************************/
//    Assert.h
/*****************************************************************************/

#ifndef _Assert_H_
#define _Assert_H_

/*****************************************************************************/

#ifdef DEBUG
#define ASSERT(x) if(!(x)) \
    { fprintf(stderr, \
             "** Assertion (" #x " ) failed at line %d of file \"%s\". ",\
     __LINE__, __FILE__ ) ; \
     abort() ; }

  // A simple thing to toss in programs to find where they are hanging
#define STATUS    do { \
        fprintf(stderr,"At line %d of file %s.\n", __LINE__, __FILE__ ); \
        } while(0)

#else

#define ASSERT(x);
#define STATUS   ;

#endif

/*****************************************************************************/

#endif _Assert_H_

