/*****************************************************************************/
//    GenericIndexSet.C
/*****************************************************************************/

#include "Globals.h"
#include "GenericIndexSet.h"

#include "Unparse.h"

/*****************************************************************************/
int corGenericIndexSet::add_all_indices( corStorageRelation *reln)
{
    if (rel->arity() != reln->arity()) {
        fprintf(corexEnv->error_file,
            "add_all_indices: relations of different arities.\n");
        return COR_I_FAIL;
    }
    for (int i=0; i < num_in_array; i++) {
        (Indices[i])->add_index_to_reln(reln);
    }
    return COR_I_SUCCESS;  
}

/*****************************************************************************/
void corGenericIndexSet::print_adornments(FILE *outf)
{
    fprintf(outf, ": indexes ");
    for (int i = 0; i < num_in_array; i++) {
        // NOTE:: right now, only argument form indices are printed out
        if (Indices[i]->argset) {
            corprint_adornment(*(Indices[i]->argset), outf);
            fputs(" ",outf);
        }
    }
}

/*****************************************************************************/

