/*****************************************************************************/
//    ObjectCount.C
/*****************************************************************************/

#include "ObjectCount.h"

#include "TupleIterator.h"

/*****************************************************************************/

int corC_NewFunctorCount = 0;
int corC_NewFunctorSize = 0;
int corC_DeleteFunctorCount = 0;
int corC_DeleteFunctorSize = 0;
int corC_NewArgListCount = 0;
int corC_NewArgListSize = 0;
int corC_NewTupleCount = 0;
int corC_NewTupleSize  = 0;
int corC_DeleteTupleCount = 0;
int corC_DeleteTupleSize  = 0;
int corC_ConstructEnvCount = 0;
int corC_ConstructEnvSize = 0;
int corC_DestructEnvCount = 0;
int corC_DestructEnvSize = 0;
int corC_NewGArraySize = 0;
int corC_DeleteGArraySize = 0;

/*****************************************************************************/
void corDumpCounts(FILE *fd)
{
    fprintf(fd, 
    "[Tuples:  Constructs: %d (size: %d), Destructs: %d (size: %d)]\n",
        corC_NewTupleCount, corC_NewTupleSize,
        corC_DeleteTupleCount, corC_DeleteTupleSize);
    fprintf(fd, 
    "[BindEnv: Constructs: %d (size: %d), Destructs: %d (size: %d)]\n",
          corC_ConstructEnvCount, corC_ConstructEnvSize,
          corC_DestructEnvCount, corC_DestructEnvSize);
    fprintf(fd,
        "[Functor Constructs: %d (size: %d), Destructs: %d (size: %d)]\n",
        corC_NewFunctorCount, corC_NewFunctorSize,
        corC_DeleteFunctorCount, corC_DeleteFunctorSize);
    fprintf(fd, "[ArgList Constructs: %d (size: %d)]\n",
        corC_NewArgListCount, corC_NewArgListSize);
    fprintf(fd, "[Integer constructs: %d, Double constructs: %d]\n",
     corC_NewIntCount, corC_NewDoubleCount);
    fprintf(fd, "[Arrays: construct size: %d, destruct size: %d]\n",
    corC_NewGArraySize, corC_DeleteGArraySize );
    fprintf(fd, 
    "[HashIndex: constructs: %d (size: %d), destructs %d (size: %d)]\n",
      corC_NewHashIndex, corC_NewHashIndexSize,
      corC_DeleteHashIndex, corC_DeleteHashIndexSize) ;
    fprintf(fd, "[HashRelation: constructs: %d, destructs: %d]\n",
      corC_NewHashRelation, corC_DeleteHashRelation);
    fprintf(fd, "[PipelinedExecInfo: Constructs: %d, Destructs: %d]\n",
        corC_PipelinedConstructs, corC_PipelinedDestructs);
    fprintf(fd, "[TupleIterators: construct size: %ld, destruct size: %ld]\n",
      corC_tupleiterConstructs * sizeof(corTupleIterator),
      corC_tupleiterDestructs * sizeof(corTupleIterator));
}

/*****************************************************************************/
void corResetCounts()
{
    corC_NewTupleCount = corC_NewTupleSize = 0;
    corC_DeleteTupleCount = corC_DeleteTupleSize = 0;
    corC_ConstructEnvCount = corC_ConstructEnvSize = 0;
    corC_DestructEnvCount = corC_DestructEnvSize = 0;
    corC_NewFunctorCount = corC_NewFunctorSize = 0;
    corC_NewArgListCount = corC_NewArgListSize = 0;
    corC_NewIntCount = corC_NewDoubleCount = 0;
    corC_NewGArraySize = corC_DeleteGArraySize = 0;
    corC_NewHashIndex =  corC_NewHashIndexSize = 0;
    corC_DeleteHashIndex =  corC_DeleteHashIndexSize = 0;
    corC_NewHashRelation = corC_DeleteHashRelation = 0;
}

/*****************************************************************************/

