/*****************************************************************************/
//    ModuleInfo.C
/*****************************************************************************/

#include "ModuleInfo.h"

#include "Globals.h"

/*****************************************************************************/
void corModuleInfo::init_flags()
{
    PreProcessing = corexEnv->C_preprocessing_default;
    Rewriting = corexEnv->C_rewriting_default;
    UseSupplementaryMagic = corexEnv->C_use_supplementary_magic_default;
    UseMagic = corexEnv->C_use_magic_default;
    SupMagicIndexing = corexEnv->C_sup_magic_indexing_default;
    CheckSubsum = corexEnv->C_check_subsum_default;
    MultiSet = corexEnv->C_multisets_default;
    IndexDeltas = corexEnv->C_index_deltas_default;
    UseFactorMagic = corexEnv->C_use_factor_magic_default;
    UseReturnUnify = corexEnv->C_use_return_unify_default;
    UsePipelining = corexEnv->C_use_pipelining_default;
    UseOrdSearch = corexEnv->C_use_ordsearch_default;
    HasPrioritize = 0;
    EagerEval = corexEnv->C_use_eager_eval_default;
    Monotonic = corexEnv->C_use_monotonic_default;
    UseExistOpt = corexEnv->C_use_exist_opt_default;
    UseFactoring = corexEnv->C_use_factoring_default;
    UsePredicateSN = corexEnv->C_use_predicate_sn_default;
    SaveModule = corexEnv->C_save_module_default;
    NonGroundFacts = corexEnv->C_non_ground_facts_default;
    DiskRel = corexEnv->C_diskrel_default;
    NestedSccEval = corexEnv->C_nested_scc_eval_default; // added by Ken

    SingleScc = corexEnv->C_single_scc_default;
    SingleAnswer = corexEnv->C_single_answer_default;
    ConvertFunctions = corexEnv->C_convert_functions_default;
}

/*****************************************************************************/
void corModuleInfo::init()
{
    name = NULL;
    ExportedPreds = NULL;
    ExportedCount = 0;
    init_flags();
}

/*****************************************************************************/

