/*****************************************************************************/
//    LinkedRelation.h
/*****************************************************************************/

#ifndef _LinkedRelation_H_
#define _LinkedRelation_H_

#include "Relation.h"
#include "HashIndex.h"
#include "HashIndexSet.h"

/*****************************************************************************/

class corLinkedRelation : public corStorageRelation {
public:
    corHashIndexSet index_set;
    corLinkedRelation(int _arity, int _delta = -1);
    virtual corRMark* getMark();

    virtual int insert_raw(corTuple *tuple);

    void initialize_iterator(corTupleIterator&);
    virtual corBindEnv *get_next(corTupleIterator&);
    virtual corTuple *get_next_tuple(corTupleIterator& it);
    virtual void release(corTupleIterator& it);
    virtual int is_subsumed(corTuple *tuple, corRMark *startmark=NULL,
        corRMark *endmark=NULL);

    //    Indexing related methods
    virtual corGenericIndexSet *get_index_set() { return &index_set ;}
    virtual corGenericIndex *create_index_object(corBitVector *bv) {
        return new corHashIndex(this, bv, -1);
    }
    virtual corGenericIndex *create_index_object(corArgList *pat, int n_var,
        corArgList *v_nm)
    {
        return new corHashIndex(this, pat, n_var, v_nm);
    }

    void free_linked_tuples();
    virtual void free_all() { corTupleList::free_all(); }
    virtual void print_name(FILE *outf);
    virtual void empty_relation(int deleteTuples=0);
    virtual ~corLinkedRelation() { free_all(); count = 0; }
};

/*****************************************************************************/

#endif _LinkedRelation_H_

