/*****************************************************************************/
//    RelationList.h
/*****************************************************************************/

#ifndef _RelationList_H_
#define _RelationList_H_

#include "StorageRelation.h"
#include "Assert.h"

/*****************************************************************************/

class corRelationLink {
public:
    corRelationLink *next;
    corStorageRelation *reln;

    corRelationLink(corStorageRelation *r, corRelationLink *n = NULL) {
        reln = r;
        next = n;
    }
};

/*****************************************************************************/

class corRelationList {
public:
    corRelationLink *reln_chain;        // head of list of (Linked) Relations
    corRelationLink *reln_lastptr;        // points to last RelationLink (delta new)
    corRelationList() {
        reln_chain = NULL;
        reln_lastptr = NULL;
    }

    void append_relation(corStorageRelation* _rel);
    void append(corRelationLink * rell);
    
    inline void insert_tuple(corTuple *tuple)
    {
        ASSERT((reln_lastptr != NULL) && (reln_lastptr->reln != NULL));
        reln_lastptr->reln->insert_tuple(tuple);
    }
};

/*****************************************************************************/

#endif _RelationList_H_

