/*****************************************************************************/
//    PredAnnotations.h
/*****************************************************************************/

#ifndef _PredAnnotations_H_
#define _PredAnnotations_H_

#include "Arg.h"
#include "SymbolArg.h"
#include "ArgList.h"
#include "BitVector.h"

/*****************************************************************************/

class corPredAnnotations {
    struct corPredAnnotations *_next;
public:
    corSymbol* pred;
    corArgList* arglist1;
    corArgList* arglist2;
    corBitVector* adorn;
    corCArg op_arg;            // Operation and arg for aggregate selections */
    int check_subsum;

    corPredAnnotations(corSymbol *pred1, struct corPredAnnotations *next1);
    corPredAnnotations* next()            { return _next;}
    corPredAnnotations* link(corPredAnnotations *tail) {
        _next = tail;
        return this;
    }
    void print(FILE *file, int adorned = 1); 
};

/*****************************************************************************/

#endif _PredAnnotations_H_

