// *************************************************************************
//    Rule.C
// *************************************************************************

#include "Rule.h"
#include "Literal.h"

// *************************************************************************
corClause::corClause()
{
    link.next = NULL;
    link.prevptr = NULL;
    num_var_names = 0;
    var_names = NULL;
    head = NULL;
    num_preds = 0;
    head_deletes_count = 0;
    head_deletes = NULL;
    preds = NULL;
    sips = NULL;
    line_number = -1;
    type = COR_NORMALRULE;

    clause_names = NULL;
}

// *************************************************************************
corClause::~corClause()
{
}

// *************************************************************************
//    Makes a copy of the header fields of the rule, but not the head or body
//    predicates.  Should be called copy_proto_rule.

corClause *corcopy_rule(corClause *prototype)
{
    register i;
    register corClause *rule;

    rule = new corClause;

            // These are now the defaults in the constructor
    //rule->link.next = NULL ;
    //rule->link.prevptr = NULL ;
    //rule->num_var_names = 0;
    //rule->var_names = NULL;
    //rule->head = NULL ;
    //rule->num_preds = 0 ;
    //rule->head_deletes_count = 0;
    //rule->head_deletes = NULL;
    //rule->preds = NULL ;
    //rule->sips = NULL ;
    //rule->line_number = -1 ;
    //rule->type = COR_NORMALRULE ;

    if (prototype) {
        rule->clause_names = prototype->clause_names;
        if (prototype->num_var_names > 0) {
            i = prototype->num_var_names;
            rule->num_var_names = i;
            rule->var_names = new Name[i];
            while (--i >= 0) rule->var_names[i] = prototype->var_names[i];
            rule->type = prototype->type ;
        }
        rule->line_number = prototype->line_number;
    }
    else {
        rule->clause_names = NULL;
    }
    return rule;
}

// *************************************************************************
void coralloc_preds(corClause *rule, int count)
{
    rule->num_preds = count;
    rule->preds = new (corLiteral*)[count];
}

// *************************************************************************

