/*****************************************************************************/
//    SMUtil.C
/*****************************************************************************/

#ifdef WITH_PERSISTENCE


#include "Globals.h"
#include "CoralError.h"
#include "SMUtil.h"
#include "sm_client.h"
#include "Config.h"
#include "Schema.h"
#include "IndexStruct.h"
#include "BPlusTreeIndex.h"
#include "FileDescStruct.h"
#include "BufferGroup.h"
#include "Transaction.h"
#include "Catalog.h"
#include "StorageManager.h"



/*****************************************************************************/
/*
    This function is called by Gram.y . Those applications that do not
    require linking with persistence code, are instead linked with
    the routine of the same name in dummy.C, that does nothing
*/

void commitTrans()
{
    if (SM_initialized) SM.commitTrans();
}

/*****************************************************************************/
void abortTrans()
{
    if (SM_initialized) SM.abortTrans();
}

/*****************************************************************************/
void shutdown_server()
{
    if (SM_initialized) {
        SM.shutdown();
    }
}

/*****************************************************************************/
void sm_init()
{
    SM.init();
}

/*****************************************************************************/
//    Check Storage Manager return codes

int ErrorCheck (int e, char* routine)
{
    if (e < 0) {
        if (verboseError) {
            if (!SM_initialized) {
                fputs(
                    "Warning: Cannot connect to EXODUS storage manager\n",
                    corexEnv->error_file);
            }
            fprintf(corexEnv->error_file,
                "Got a Storage Manager error from %s\n", routine);
            fprintf(corexEnv->error_file, "Error = %s\n", sm_Error(sm_errno));
            fflush(corexEnv->error_file);
            // if (SM_initialized)
            //SM.shutdown(); -- Not for simple errors!
        }
        return 1;
    }
    return(0);
}

/*****************************************************************************/

#endif WITH_PERSISTENCE

