/*****************************************************************************/
//    Tuple.C
/*****************************************************************************/

#include "Tuple.h"

#include "VersionedBindEnv.h"

/*****************************************************************************/
/*

Term *Tuple::term(int i)
{
    Term term;
    term.expr = (*_args)[i];
    term.bindenv = bindenv;
    return (term);
}
*/

/*****************************************************************************/
corCArg& corTuple::operator [](int i) const
{
    corTerm *term1 = term(i);
    
    FULL_DEREFERENCE_TERM(*term1);
    return term1->expr;
}

/*****************************************************************************/
int corTuple::isConstant()
{
    int i;
    for(i=0;i < arity();i++)
        if (! arg(i).isConstant()) return (0); 
    return (1);
}

/*****************************************************************************/
corBindEnv * corTuple::make_bindenv_version()
{
    if (default_bindenv()) {
        corBindEnv *newenv;
        if (env_size == 0)
            return NULL;
        else if (isConstant())
            return NULL;

        newenv = new corVersionedBindEnv(env_size);
        return newenv;
    }
    else {
        if (isConstant()) return NULL;
        return bindenv->make_version();
    }
}

/*****************************************************************************/

extern corArrayBindEnv NullEnv;

/*****************************************************************************/
void corTuple::printon(FILE *file) const
{
    if (default_bindenv())
        (*_args).print(NULL, file);
    else
        (*_args).print(bindenv, file);
}

/*****************************************************************************/
corTuple* corTuple::rename(corBindEnv *env)
{
    // rename tuple with variables starting from after the maximum variable in
    // env.
    // CopyArgs resizes env to handle the extra variables.

    if (env_size == 0)
        return this;

    corArgList *copy_args = new corArgList(arity());
    int env_size = corCopyArgs(copy_args, & args(), bindenv,
        arity(), env);
    corTuple *newtuple = new corTuple(copy_args, env);
    newtuple->env_size = env_size;
    return newtuple;
}

/*****************************************************************************/

