/*****************************************************************************/
//    TupleList.h
/*****************************************************************************/

#ifndef _TupleList_H_
#define _TupleList_H_

#include "Tuple.h"

/*****************************************************************************/
//    TupleLink is used to chain Tuples together to form a LinkedRelation

class corTupleLink {
public:
    corTupleLink *next;
    corTuple *tuple;

    corTupleLink(corTuple *v, corTupleLink *n = NULL) {
        tuple = v;
        next = n;
    }
};

/*****************************************************************************/
//    TupleList is a list of Tuples (chained using TupleLink).

class corTupleList {
public:
    corTupleLink* chain;            // head of list of (Linked)Tuples
    corTupleLink** lastptr;        // points to last pointer of list

    corTupleList() {
        chain = NULL;
        lastptr = &chain;
    }

    inline void tlist_insert_tuple(corTuple  *tuple) {
        if (!tuple->is_deleted()) {
            // only if tuple not deleted
            corTupleLink *node = new corTupleLink(tuple,NULL);
            *lastptr = node; lastptr = &node->next;
        }
    }

    void free_all();
};

/*****************************************************************************/

#endif _TupleList_H_

