/*****************************************************************************/
//	Adorn.h
/*****************************************************************************/

#ifndef _Adorn_H_
#define _Adorn_H_

#include "Collection.h"
#include "Literal.h"
#include "SymbolArg.h"
#include "BitVector.h"
#include "Rule.h"

/*****************************************************************************/

int adorn(struct corcollection *pre_ad_rules, struct corcollection * ad_rules);

void set_best_allowed_adorn(corLiteral *lit);
int is_disallowed_adorn(Name name, corBitVector &adorn);

void preprocess_for_grouping(struct corcollection *orig_rules,
	struct corcollection *pre_ad_rules);

Name build_ad_grouped_pred_name(corLiteral *head);
int grouped_pred_arity(corLiteral *head);

char *init_any_adorn(int num);

void create_grouping_rule_1(corClause *rule, Name new_pred_name,
	int new_pred_arity, struct corcollection *pre_ad_rules);
void create_grouping_rule_2(corClause *rule, Name new_pred_name,
	int new_pred_arity, struct corcollection *pre_ad_rules);

/*****************************************************************************/

#endif _Adorn_H_

