
module extens_eg3.
export foreach(fbb).

% The for-each definition below is a useful template for iterating 
% over arrays (both logical and destructive).
% A sample session is included below:
%
%---------------------------------
% store(X) := array(X,5), bind(X,0,0), bind(X,1,1), bind(X,2,2), bind(X,3,3),
%        bind(X,4,4).   
% consult(extensj.P).
% ?store(X), foreach(I,0,4), lookup(X,I,Val), print(Val).
%
%----------------------------------

% Generates all integer values in the range Low to High, both inclusive.

foreach(Low,Low,High) :- Low <= High.
foreach(I+1,Low,High) :- foreach(I,Low,High), I < High.

end_module.

