
module declne_eg2a.
export notintoys(f).

% Illustrates dangers of floundering programs.

person(john).
person(susan).
employed(susan,marketing).

notintoys(X) :- person(X), not employed(X,Y), Y=toys.

end_module.

module declne_eg2b.
export unemployed(f).

% This program, while it does not meet the non-floundering restriction,
% nonetheless behaves reasonably.  The key point is that variables
% in the negated literal are not further instantiated later in the rule.

person(john).
person(susan).
employed(susan,marketing).

unemployed(X) :- person(X), not employed(X,Y).

end_module.
